/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package wawi.gui.admingui.gui;

import java.awt.Color;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import static javax.swing.JOptionPane.showMessageDialog;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import wawi.fachlogik.adminsteuerung.grenz.EinlieferungGrenz;
import wawi.fachlogik.adminsteuerung.steuer.LagerSteuerung;
import wawi.gui.admingui.resources.MyListModelEinlieferungenShow;

/**
 *
 * @author gromow
 */
public class FrameEinlieferungenShow extends javax.swing.JFrame {

    private LagerSteuerung ls;
    private int hiddenValueForEinlieferung;
    private Date datevon;
    private Date datebis;
    private List<EinlieferungGrenz> einlieferunggrenzlist;
    private MyListModelEinlieferungenShow mylistmodeleinlieferungenshow;
    private int selectedRowIndex;
    private EinlieferungGrenz einlieferunggrenz;
    private FrameEinlieferungenPositionShow frameeinlieferungenpositionenshow;

    /**
     * Creates new form FrameEinlieferungenShow
     */
    public FrameEinlieferungenShow() {
        initComponents();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        lieferpositionenShow = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        fieldVon = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        fieldBis = new javax.swing.JTextField();
        searchDate = new javax.swing.JButton();
        jLabel5 = new javax.swing.JLabel();
        fielById = new javax.swing.JTextField();
        searchById = new javax.swing.JButton();
        close = new javax.swing.JButton();
        lblOutput = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        jLabel1.setFont(new java.awt.Font("Lucida Grande", 1, 13)); // NOI18N
        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText("Einlieferungen");

        ls = new LagerSteuerung();
        einlieferunggrenzlist = ls.einlieferungenAnzeigen();
        MyListModelEinlieferungenShow mylistmodeleinlieferungenshow = new MyListModelEinlieferungenShow();
        mylistmodeleinlieferungenshow.setEinlieferunggrenzlist(einlieferunggrenzlist);
        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jTable1.setModel(mylistmodeleinlieferungenshow.buildTableModel());
        /* Bis dahin soll die Liste erstellt werden */
        /* Ab hier ist der Listener und noEdit */
        jTable1.getSelectionModel().addListSelectionListener(new ListSelectionListener(){
            public void valueChanged(ListSelectionEvent event) {
                // http://stackoverflow.com/questions/10128064/jtable-selected-row-click-event
                // print first column value from selected row
                selectedRowIndex = jTable1.getSelectedRow();
                String val = jTable1.getValueAt(jTable1.getSelectedRow(), 0).toString();
                hiddenValueForEinlieferung = Integer.parseInt(val);
                lblOutput.setForeground(Color.BLACK);
                lblOutput.setText("Einlieferung : "+hiddenValueForEinlieferung);
            }
        });
        //http://stackoverflow.com/questions/1990817/how-to-make-a-jtable-non-editable
        for (int c = 0; c < jTable1.getColumnCount(); c++)
        {
            Class<?> col_class = jTable1.getColumnClass(c);
            jTable1.setDefaultEditor(col_class, null);        // remove editor
        }
        jScrollPane1.setViewportView(jTable1);

        lieferpositionenShow.setText("Lieferpositionen anzeigen");
        lieferpositionenShow.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                lieferpositionenShowActionPerformed(evt);
            }
        });

        jLabel2.setFont(new java.awt.Font("Lucida Grande", 1, 13)); // NOI18N
        jLabel2.setText("Suchoptionen");

        jLabel3.setText("von");

        fieldVon.setText("tt-mm-jjjj");

        jLabel4.setText("bis");

        fieldBis.setText("tt-mm-jjjj");

        searchDate.setText("Filtern");
        searchDate.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                searchDateActionPerformed(evt);
            }
        });

        jLabel5.setText("ID:");

        searchById.setText("Suchen");
        searchById.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                searchByIdActionPerformed(evt);
            }
        });

        close.setText("Schließen");
        close.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(369, 369, 369)
                        .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGap(144, 144, 144)
                        .addComponent(lieferpositionenShow))
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jScrollPane1)
                            .addGroup(layout.createSequentialGroup()
                                .addGap(6, 6, 6)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(layout.createSequentialGroup()
                                        .addComponent(jLabel2)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(lblOutput)
                                        .addGap(0, 0, Short.MAX_VALUE))
                                    .addGroup(layout.createSequentialGroup()
                                        .addComponent(jLabel3)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(fieldVon, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(jLabel4)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(fieldBis, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(searchDate, javax.swing.GroupLayout.PREFERRED_SIZE, 73, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addGap(109, 109, 109)
                                        .addComponent(jLabel5)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(fielById, javax.swing.GroupLayout.PREFERRED_SIZE, 46, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(searchById, javax.swing.GroupLayout.PREFERRED_SIZE, 76, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .addComponent(close, javax.swing.GroupLayout.PREFERRED_SIZE, 91, javax.swing.GroupLayout.PREFERRED_SIZE)))))))
                .addContainerGap())
        );

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {close, searchById, searchDate});

        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(24, 24, 24)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(lieferpositionenShow))
                .addGap(18, 18, 18)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 292, Short.MAX_VALUE)
                .addGap(39, 39, 39)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(lblOutput))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(fieldVon, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel4)
                    .addComponent(fieldBis, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(searchDate)
                    .addComponent(jLabel5)
                    .addComponent(fielById, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(searchById)
                    .addComponent(close))
                .addGap(12, 12, 12))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void closeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeActionPerformed
        // TODO add your handling code here:
        setDefaultCloseOperation(DISPOSE_ON_CLOSE);
        dispose();
    }//GEN-LAST:event_closeActionPerformed

    private void searchDateActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_searchDateActionPerformed
        // TODO add your handling code here:
        String von = fieldVon.getText();
        String bis = fieldBis.getText();

        if (von.equals("") || bis.equals("") || bis.contains("m") || von.contains("m")) {
            showMessageDialog(null, "Bitte das Datum ergänzen");
            lblOutput.setForeground(Color.red);
            lblOutput.setText("Fehler!");

        } else {
            jTable1 = new javax.swing.JTable();
            ls = new LagerSteuerung();

            //String ins Datum umwandeln
            DateFormat formatter = new SimpleDateFormat("dd-MM-yyyy");

            try {
                datevon = formatter.parse(von);
                datebis = formatter.parse(bis);
            } catch (ParseException ex) {
                Logger.getLogger(FrameEinlieferungenShow.class.getName()).log(Level.SEVERE, null, ex);
            }

            try {
                einlieferunggrenzlist = ls.einlieferungenAnzeigen(datevon, datebis);

                lblOutput.setText("Gefunden: " + einlieferunggrenzlist.size());
            } catch (ParseException ex) {
                Logger.getLogger(FrameBestellungenShow.class.getName()).log(Level.SEVERE, null, ex);
            }

            mylistmodeleinlieferungenshow = new MyListModelEinlieferungenShow();
            //die fertige, nach Datum sortierte GrenzListe wird der Klasse übergegeben
            mylistmodeleinlieferungenshow.setEinlieferunggrenzlist(einlieferunggrenzlist);

            jTable1.setModel(mylistmodeleinlieferungenshow.buildTableModel());

            /* Listener Event aus Google */
            jTable1.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
                public void valueChanged(ListSelectionEvent event) {
                    // http://stackoverflow.com/questions/10128064/jtable-selected-row-click-event

                    selectedRowIndex = jTable1.getSelectedRow();
                    String val = jTable1.getValueAt(jTable1.getSelectedRow(), 0).toString();
                    hiddenValueForEinlieferung = Integer.parseInt(val);
                    lblOutput.setText("Einlieferung : " + hiddenValueForEinlieferung);
                }
            });

            //http://stackoverflow.com/questions/1990817/how-to-make-a-jtable-non-editable
            for (int c = 0; c < jTable1.getColumnCount(); c++) {
                Class<?> col_class = jTable1.getColumnClass(c);
                jTable1.setDefaultEditor(col_class, null);        // remove editor
            }
            jScrollPane1.setViewportView(jTable1);
            /* Listener Event aus Google */

        }
    }//GEN-LAST:event_searchDateActionPerformed

    private void searchByIdActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_searchByIdActionPerformed
        // TODO add your handling code here:
        if (fielById.getText().equals("")) {
            showMessageDialog(null, "Tragen Sie Bitte id-Nummer ein!");
            lblOutput.setForeground(Color.red);
            lblOutput.setText("Fehler!");
        } else {
            jTable1 = new javax.swing.JTable();

            ls = new LagerSteuerung();

            hiddenValueForEinlieferung = Integer.parseInt(fielById.getText());

            einlieferunggrenz = ls.einlieferungenAnzeigen(hiddenValueForEinlieferung);
            if (einlieferunggrenz == null) {
                showMessageDialog(null, "Nichts gefunden!");
            lblOutput.setForeground(Color.red);
            lblOutput.setText("Fehler!");
            } else {
                einlieferunggrenzlist = new ArrayList<>();
                einlieferunggrenzlist.add(einlieferunggrenz);

                mylistmodeleinlieferungenshow = new MyListModelEinlieferungenShow();

                mylistmodeleinlieferungenshow.setEinlieferunggrenzlist(einlieferunggrenzlist);

                jTable1.setModel(mylistmodeleinlieferungenshow.buildTableModel());
                /* Listener Event aus Google */

                jTable1.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
                    public void valueChanged(ListSelectionEvent event) {
                        // http://stackoverflow.com/questions/10128064/jtable-selected-row-click-event
                        // print first column value from selected row
                        selectedRowIndex = jTable1.getSelectedRow();
                        String val = jTable1.getValueAt(jTable1.getSelectedRow(), 0).toString();

                        hiddenValueForEinlieferung = Integer.parseInt(val);
                        lblOutput.setText("Einlieferung : " + hiddenValueForEinlieferung);
                    }
                });

                //http://stackoverflow.com/questions/1990817/how-to-make-a-jtable-non-editable
                for (int c = 0; c < jTable1.getColumnCount(); c++) {
                    Class<?> col_class = jTable1.getColumnClass(c);
                    jTable1.setDefaultEditor(col_class, null);        // remove editor
                }
                jScrollPane1.setViewportView(jTable1);
            }
        }
    }//GEN-LAST:event_searchByIdActionPerformed

    private void lieferpositionenShowActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_lieferpositionenShowActionPerformed
        // TODO add your handling code here:
        
        FrameEinlieferungenPositionShow.setEinlieferunggrenz(einlieferunggrenzlist.get(selectedRowIndex));

        frameeinlieferungenpositionenshow = new FrameEinlieferungenPositionShow();
        frameeinlieferungenpositionenshow.setTitle("Lieferposition anzeigen");
        frameeinlieferungenpositionenshow.setLocationRelativeTo(null);
        frameeinlieferungenpositionenshow.setVisible(true);

    }//GEN-LAST:event_lieferpositionenShowActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(FrameEinlieferungenShow.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(FrameEinlieferungenShow.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(FrameEinlieferungenShow.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(FrameEinlieferungenShow.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new FrameEinlieferungenShow().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton close;
    private javax.swing.JTextField fielById;
    private javax.swing.JTextField fieldBis;
    private javax.swing.JTextField fieldVon;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTable1;
    private javax.swing.JLabel lblOutput;
    private javax.swing.JButton lieferpositionenShow;
    private javax.swing.JButton searchById;
    private javax.swing.JButton searchDate;
    // End of variables declaration//GEN-END:variables
}
